function ll = Estimation_function_M2(b0,x,err1,err2,err3,err4,err5, times,np,nv,ni,ncoefhet,ncop,nrep)
%+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++%
%                            FUNCTION                         %
%                        Learning Model          %  
%                        Matrices voor random nrs             %
%+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++%

% qbm = mean quality belief; qbv= variance quality belief 
% note: heterogeneous pars come first in b0 (first ncoefhet*2 pars), then homogeneous 
% note: first coef is risk aversion   

sl=zeros(np,1);
% make sure to use same rand nrs across iterations  
occ=zeros(np,1);

lnsigv=b0(2*ncoefhet+1,1);
lninit=b0(2*ncoefhet+12:2*ncoefhet+19,1);

lninitd=b0(2*ncoefhet+2,1);
lninitdt2=b0(2*ncoefhet+3,1);
delqb=zeros(ni,1);
% voer eerst afwijking delta per merk in, merk 8=referentie, merken 4 en 5 geen innovaties
delqb(2:4,1)=b0(2*ncoefhet+4:2*ncoefhet+6,1);
delqb(6:7,1)=b0(2*ncoefhet+7:2*ncoefhet+8,1);
delqb(8,1)=(-1)*sum(delqb,1);
% tel voor elk merk de parameter voor overall type 1 quality change op,
% merk 4 en 5 weer op nul want geen innovaties
delqb=b0(2*ncoefhet+9,1);
delqb(1,1)=0;%h no innovations
delqb(5,1)=0;%d no innovations
% tel voor ek merk de parameter voor overall type 2 quality change op,
% merk 4 en 5 weer op nul want geen innovaties
delqb2=b0(2*ncoefhet+10,1);
delqb2(1,1)=0;%h no innovations
delqb2(5,1)=0;%d no innovations
lnsigv_adv=b0(2*ncoefhet+11,1);
rho_0=0;
cops=b0(2*ncoefhet+20:2*ncoefhet+19+ncop,1);

b0=(reshape(b0(1:2*ncoefhet,1)',2,ncoefhet))';
mm=b0(:,1);
ss=b0(:,2);

% start loop over households */

parfor nr=1:np;  
    count=sum(times(1:nr,1),1)-times(nr,1);
	n=times(nr,1)*ni;
	% standard normal errors for the household: one for each heterogeneous coef, 
	% and for each trip (signal) 
	err=reshape(err1(:,:,nr),ncoefhet,nrep); % ncoefhet rows, nrep columns  
	err_sig=err2((count+1:count+times(nr,1)),:); % times(nr,1) rows, nrep columns 
	err_sig_adv=err5((count+1:count+times(nr,1)),:); % times(nr,1) rows, nrep columns 
    err_d=reshape(err3(:,:,nr),ni,nrep); % ni rows, nrep columns
    err_d2=reshape(err4(:,:,nr),ni,nrep); % ni rows, nrep columns
    beta=repmat(mm,1,nrep)+repmat(ss,1,nrep).*err; % ncoefhet rows, nrep columns
	beta_del=repmat(delqb,1,nrep)+repmat(vertcat(ss(4:10,1),zeros(1,1)),1,nrep).*err_d; %ni rows, nrep columns
    beta_del2=repmat(delqb2,1,nrep)+repmat(vertcat(ss(4:10,1),zeros(1,1)),1,nrep).*err_d2;
    betacop=repmat(cops,1,nrep); %ncop rows, nrep columns
    xh=reshape(x((count+1:count+times(nr,1)),1:nv*ni)',nv,n)';
	ini=xh(1:n,2);
    	
    yh=reshape(xh(:,2)',ni,(n/ni))';
	gh=reshape(xh(:,3)',ni,(n/ni))';
	quan=reshape(xh(:,16)',ni,(n/ni))';
	ah=reshape(xh(:,19)',ni,(n/ni))';
    quana=reshape(xh(:,20)',ni,(n/ni))';
    % to avoid numerical problems: add nonzero value to quan if item not
    % bought or received
    quan=quan+.00001*(ones((n/ni),ni)-(yh+gh));
    quana=quana+.00001*(ones((n/ni),ni)-(ah));
    
    xh=reshape(xh',nv*ni,(n/ni))';
    
    qbm1=zeros(times(nr,1)+1,ni,nrep); % mean quality beliefs, one extra row for initialization 
	qbv1=zeros(times(nr,1)+1,ni,nrep); % variance quality beliefs, one extra row for initialization
    
    qbdm1=zeros(times(nr,1)+1,ni,nrep); % mean quality change beliefs, one extra row for initialization
    qbdv1=zeros(times(nr,1)+1,ni,nrep); % variance quality change beliefs, one extra row for initialization
    qbc1=zeros(times(nr,1)+1,ni,nrep); % covariance quality-quality change beliefs
    
    qbdm1t2=zeros(times(nr,1)+1,ni,nrep); % mean quality change beliefs, one extra row for initialization
    qbdv1t2=zeros(times(nr,1)+1,ni,nrep); % variance quality change beliefs, one extra row for initialization
    qbc1t2=zeros(times(nr,1)+1,ni,nrep); % covariance quality-quality change beliefs
    
	% set initial beliefs = true mean qualities, fixed at zero for brand 8 
	qbm1(1,:,:)=repmat((horzcat(mm(4:10,1)',zeros(1,1))),[1,1,nrep]);
    qbv1(1,:,:)=repmat(exp(lninit),[1,1,nrep]);
    
    qbdm1(1,:,:)=repmat(delqb,[1,1,nrep]);
    qbdv1(1,:,:)=repmat((ones(1,ni)*exp(lninitd)),[1,1,nrep]);
    qbc1(1,:,:)=rho_0*sqrt(qbv1(1,:,:).*qbdv1(1,:,:));
    
    qbdm1t2(1,:,:)=repmat(delqb2,[1,1,nrep]);
    qbdv1t2(1,:,:)=repmat((ones(1,ni)*exp(lninitdt2)),[1,1,nrep]);
    qbc1t2(1,:,:)=rho_0*sqrt(qbv1(1,:,:).*qbdv1t2(1,:,:));
    
    trueq=zeros(times(nr,1)+1,ni,nrep); % varying true quality from which signals are drawn
    trueq(1,:,:)=reshape(vertcat(beta(4:10,:),zeros(1,nrep)),[1,ni,nrep]); % 1 by ni by nrep 
    rho=zeros(1,ni,nrep);
    rhot2=zeros(1,ni,nrep);
    
   		zzz1=zeros(times(nr,1),ni,nrep);
		% start loop over trips for household %
	t1=1;
    xht1=repmat((reshape(xh(t1,1:ni*nv)',nv,ni)'),[1,1,nrep]); %ni by nv by nrep
	% Calculate utility and LL
    beta1=repmat(reshape(beta,[1,ncoefhet,nrep]),[ni,1,1]); % beta1 nu ni by ncoefhet by nrep
    betacop1=repmat(reshape(betacop,[1,ncop,nrep]),[ni,1,1]); %betacop1 nu ni by ncop by nrep 
            utili1= sum(beta1(:,[2:3 11:12],:) ...
                .*xht1(:,4:7,:),2);% utili1 is ni by 1 by nrep
            utili2= reshape(qbm1(t1,:,:),[ni,1,nrep])...
			+beta1(:,1,:).*(reshape(qbv1(t1,1:ni,1:nrep),[ni,1,nrep]));  
            utili3=sum(betacop1(:,:,:) ...
                .*xht1(:,21:24,:),2);  
            num1=exp(utili1+utili2+utili3); %num is ni by 1 by nrep
   			numm1=reshape(num1,[1,ni,nrep]);  %numm1 is 1 by ni by nrep
            den1=sum(numm1,2); % den1 is 1 by 1 by nrep
   			zzz1(t1,:,:)=(numm1./repmat(den1,[1,ni,1])) .^ repmat(yh(t1,:),[1,1,nrep]); %zzz1= times(nr,1) by ni by nrep
		
    % update based on signals in t
    
    % Use advertising signals first
            
       qbv1(t1+1,:,:)=repmat(((ah(t1,:))),[1,1,nrep])...
        .*qbv1(t1,:,:)./(qbv1(t1,:,:)+exp(lnsigv_adv*(ones(1,ni,nrep)))./repmat(quana(t1,:),[1,1,nrep]))...
        .*exp(lnsigv_adv*(ones(1,ni,nrep)))./repmat(quana(t1,:),[1,1,nrep])+(ones(1,ni,nrep)...
        -repmat((ah(t1,:)),[1,1,nrep])).*qbv1(t1,:,:);
    
        qbdv1(t1+1,:,:)=qbdv1(t1,:,:)-repmat(((ah(t1,:))),[1,1,nrep])...
        .*qbc1(t1,:,:).*qbc1(t1,:,:)...
        ./(qbv1(t1,:,:)+exp(lnsigv_adv*(ones(1,ni,nrep)))./repmat(quana(t1,:),[1,1,nrep]));
    
        qbdv1t2(t1+1,:,:)=qbdv1t2(t1,:,:)-repmat(((ah(t1,:))),[1,1,nrep])...
        .*qbc1t2(t1,:,:).*qbc1t2(t1,:,:)...
        ./(qbv1(t1,:,:)+exp(lnsigv_adv*(ones(1,ni,nrep)))./repmat(quana(t1,:),[1,1,nrep]));
    
        qbc1(t1+1,:,:)=repmat(((ah(t1,:))),[1,1,nrep])...
        .*qbc1(t1,:,:)./(qbv1(t1,:,:)+exp(lnsigv_adv*(ones(1,ni,nrep)))./repmat(quana(t1,:),[1,1,nrep]))...
        .*exp(lnsigv_adv*(ones(1,ni,nrep)))./repmat(quana(t1,:),[1,1,nrep])+(ones(1,ni,nrep)...
        -repmat((ah(t1,:)),[1,1,nrep])).*qbc1(t1,:,:);
        
        qbc1t2(t1+1,:,:)=repmat(((ah(t1,:))),[1,1,nrep])...
        .*qbc1t2(t1,:,:)./(qbv1(t1,:,:)+exp(lnsigv_adv*(ones(1,ni,nrep)))./repmat(quana(t1,:),[1,1,nrep]))...
        .*exp(lnsigv_adv*(ones(1,ni,nrep)))./repmat(quana(t1,:),[1,1,nrep])+(ones(1,ni,nrep)...
        -repmat((ah(t1,:)),[1,1,nrep])).*qbc1t2(t1,:,:);
     
        qbm1(t1+1,:,:)=qbm1(t1,:,:)+...
            repmat((ah(t1,:)),[1,1,nrep]) ...
		    .*(trueq(t1,:,:)...
            +ones(1,ni,nrep).*(sqrt(exp(lnsigv_adv*(ones(1,ni,nrep)) ...
			)).*repmat(reshape(err_sig_adv(t1,:),[1,1,nrep]),[1,ni,1]))-qbm1(t1,:,:))...
            .*qbv1(t1,:,:)./(qbv1(t1,:,:)+exp(lnsigv_adv*(ones(1,ni,nrep)))./repmat(quana(t1,:),[1,1,nrep])); 
        
        qbdm1(t1+1,:,:)=qbdm1(t1,:,:)+...
            repmat((ah(t1,:)),[1,1,nrep]) ...
		    .*(trueq(t1,:,:)...
            +ones(1,ni,nrep).*(sqrt(exp(lnsigv_adv*(ones(1,ni,nrep)) ...
			)).*repmat(reshape(err_sig_adv(t1,:),[1,1,nrep]),[1,ni,1]))-qbm1(t1,:,:))...
            .*qbc1(t1,:,:)./(qbv1(t1,:,:)+exp(lnsigv_adv*(ones(1,ni,nrep)))./repmat(quana(t1,:),[1,1,nrep])); 
  
        qbdm1t2(t1+1,:,:)=qbdm1t2(t1,:,:)+...
            repmat((ah(t1,:)),[1,1,nrep]) ...
		    .*(trueq(t1,:,:)...
            +ones(1,ni,nrep).*(sqrt(exp(lnsigv_adv*(ones(1,ni,nrep)) ...
			)).*repmat(reshape(err_sig_adv(t1,:),[1,1,nrep]),[1,ni,1]))-qbm1(t1,:,:))...
            .*qbc1t2(t1,:,:)./(qbv1(t1,:,:)+exp(lnsigv_adv*(ones(1,ni,nrep)))./repmat(quana(t1,:),[1,1,nrep]));

        %now use consumption signals (so use t1+1 as these are already
        % adjusted for ad signals)
   
         qbv1(t1+1,:,:)=repmat(((yh(t1,:)+gh(t1,:))),[1,1,nrep])...
        .*qbv1(t1+1,:,:)./(qbv1(t1+1,:,:)+exp(lnsigv*(ones(1,ni,nrep)))./repmat(quan(t1,:),[1,1,nrep]))...
        .*exp(lnsigv*(ones(1,ni,nrep)))./repmat(quan(t1,:),[1,1,nrep])+(ones(1,ni,nrep)...
        -repmat((yh(t1,:)+gh(t1,:)),[1,1,nrep])).*qbv1(t1+1,:,:);
        
        qbdv1(t1+1,:,:)=qbdv1(t1+1,:,:)-repmat(((yh(t1,:)+gh(t1,:))),[1,1,nrep])...
        .*qbc1(t1+1,:,:).*qbc1(t1+1,:,:)...
        ./(qbv1(t1+1,:,:)+exp(lnsigv*(ones(1,ni,nrep)))./repmat(quan(t1,:),[1,1,nrep]));
    
        qbdv1t2(t1+1,:,:)=qbdv1t2(t1+1,:,:)-repmat(((yh(t1,:)+gh(t1,:))),[1,1,nrep])...
        .*qbc1t2(t1+1,:,:).*qbc1t2(t1+1,:,:)...
        ./(qbv1(t1+1,:,:)+exp(lnsigv*(ones(1,ni,nrep)))./repmat(quan(t1,:),[1,1,nrep]));
    
        qbc1(t1+1,:,:)=repmat(((yh(t1,:)+gh(t1,:))),[1,1,nrep])...
        .*qbc1(t1+1,:,:)./(qbv1(t1+1,:,:)+exp(lnsigv*(ones(1,ni,nrep)))./repmat(quan(t1,:),[1,1,nrep]))...
        .*exp(lnsigv*(ones(1,ni,nrep)))./repmat(quan(t1,:),[1,1,nrep])+(ones(1,ni,nrep)...
         -repmat((yh(t1,:)+gh(t1,:)),[1,1,nrep])).*qbc1(t1+1,:,:);
        
        qbc1t2(t1+1,:,:)=repmat(((yh(t1,:)+gh(t1,:))),[1,1,nrep])...
        .*qbc1t2(t1+1,:,:)./(qbv1(t1+1,:,:)+exp(lnsigv*(ones(1,ni,nrep)))./repmat(quan(t1,:),[1,1,nrep]))...
        .*exp(lnsigv*(ones(1,ni,nrep)))./repmat(quan(t1,:),[1,1,nrep])+(ones(1,ni,nrep)...
         -repmat((yh(t1,:)+gh(t1,:)),[1,1,nrep])).*qbc1t2(t1+1,:,:);
     
         qbm1(t1+1,:,:)=qbm1(t1+1,:,:)+...
            repmat((yh(t1,:)+gh(t1,:)),[1,1,nrep]) ...
		    .*(trueq(t1,:,:)...
            +ones(1,ni,nrep).*(sqrt(exp(lnsigv*(ones(1,ni,nrep)) ...
			)).*repmat(reshape(err_sig(t1,:),[1,1,nrep]),[1,ni,1]))-qbm1(t1+1,:,:))...
            .*qbv1(t1+1,:,:)./(qbv1(t1+1,:,:)+exp(lnsigv*(ones(1,ni,nrep)))./repmat(quan(t1,:),[1,1,nrep])); 
        
        qbdm1(t1+1,:,:)=qbdm1(t1+1,:,:)+...
            repmat((yh(t1,:)+gh(t1,:)),[1,1,nrep]) ...
		    .*(trueq(t1,:,:)...
            +ones(1,ni,nrep).*(sqrt(exp(lnsigv*(ones(1,ni,nrep)) ...
			)).*repmat(reshape(err_sig(t1,:),[1,1,nrep]),[1,ni,1]))-qbm1(t1+1,:,:))...
            .*qbc1(t1+1,:,:)./(qbv1(t1+1,:,:)+exp(lnsigv*(ones(1,ni,nrep)))./repmat(quan(t1,:),[1,1,nrep])); 
  
        qbdm1t2(t1+1,:,:)=qbdm1t2(t1+1,:,:)+...
            repmat((yh(t1,:)+gh(t1,:)),[1,1,nrep]) ...
		    .*(trueq(t1,:,:)...
            +ones(1,ni,nrep).*(sqrt(exp(lnsigv*(ones(1,ni,nrep)) ...
			)).*repmat(reshape(err_sig(t1,:),[1,1,nrep]),[1,ni,1]))-qbm1(t1+1,:,:))...
            .*qbc1t2(t1+1,:,:)./(qbv1(t1+1,:,:)+exp(lnsigv*(ones(1,ni,nrep)))./repmat(quan(t1,:),[1,1,nrep]));
  	
        
        for t1=2:times(nr,1);
			xht1=repmat((reshape(xh(t1,1:ni*nv)',nv,ni)'),[1,1,nrep]); %ni by nv by nrep
	% forecast
        trueq(t1,:,:)=trueq(t1-1,:,:)+reshape(beta_del,[1,ni,nrep]).*reshape(xht1(:,17,:),[1,ni,nrep])...
            +reshape(beta_del2,[1,ni,nrep]).*reshape(xht1(:,18,:),[1,ni,nrep]);
        
        qbm1(t1,:,:)=qbm1(t1,:,:)+qbdm1(t1,:,:).*reshape(xht1(:,17,:),[1,ni,nrep])...
           +qbdm1t2(t1,:,:).*reshape(xht1(:,18,:),[1,ni,nrep]) ;
		
        qbv1(t1,:,:)=qbv1(t1,:,:)+reshape(xht1(:,17,:),[1,ni,nrep])...
            .*(reshape(xht1(:,17,:),[1,ni,nrep]).*qbdv1(t1,:,:)+2*qbc1(t1,:,:))...
            +reshape(xht1(:,18,:),[1,ni,nrep])...
            .*(reshape(xht1(:,18,:),[1,ni,nrep]).*qbdv1t2(t1,:,:)+2*qbc1t2(t1,:,:))  ;
        
        qbc1(t1,:,:)=reshape(xht1(:,17,:),[1,ni,nrep]).*qbdv1(t1,:,:)+qbc1(t1,:,:);
        qbc1t2(t1,:,:)=reshape(xht1(:,18,:),[1,ni,nrep]).*qbdv1t2(t1,:,:)+qbc1t2(t1,:,:);
        
        % To make sure that variance does not exceed initial variance: use trick
        rho(1,:,:)=qbc1(t1,:,:)./sqrt(qbv1(t1,:,:).*qbdv1(t1,:,:));
        qbdv1(t1,:,:)=min(qbdv1(t1,:,:),qbdv1(1,:,:));
        rhot2(1,:,:)=qbc1t2(t1,:,:)./sqrt(qbv1(t1,:,:).*qbdv1t2(t1,:,:));
        qbdv1t2(t1,:,:)=min(qbdv1t2(t1,:,:),qbdv1t2(1,:,:));
        qbv1(t1,:,:)=min(qbv1(t1,:,:),qbv1(1,:,:));
        qbc1(t1,:,:)=rho(1,:,:).*sqrt(qbv1(t1,:,:).*qbdv1(t1,:,:));
        qbc1t2(t1,:,:)=rhot2(1,:,:).*sqrt(qbv1(t1,:,:).*qbdv1t2(t1,:,:));
        
        % Calculate utility and LL
        beta1=repmat(reshape(beta,[1,ncoefhet,nrep]),[ni,1,1]); % beta1 nu ni by ncoefhet by nrep
        betacop1=repmat(reshape(betacop,[1,ncop,nrep]),[ni,1,1]); %betacop1 nu ni by ncop by nrep
            utili1= sum(beta1(:,[2:3 11:12],:) ...
                .*xht1(:,4:7,:),2);  %utili1 is ni by 1 by nrep
            utili2= reshape(qbm1(t1,:,:),[ni,1,nrep])...
			+beta1(:,1,:).*(reshape(qbv1(t1,1:ni,1:nrep),[ni,1,nrep])); 
            utili3=sum(betacop1(:,:,:) ...
                .*xht1(:,21:24,:),2);   
            num1=exp(utili1+utili2+utili3); %num is ni by 1 by nrep
   			numm1=reshape(num1,[1,ni,nrep]);  %numm1 is 1 by ni by nrep
            den1=sum(numm1,2); % den1 is 1 by 1 by nrep
   			zzz1(t1,:,:)=(numm1./repmat(den1,[1,ni,1])) .^ repmat(yh(t1,:),[1,1,nrep]); %zzz1= times(nr,1) by ni by nrep
		
    % update based on signals in t
    
    % Use advertising signals first
            
       qbv1(t1+1,:,:)=repmat(((ah(t1,:))),[1,1,nrep])...
        .*qbv1(t1,:,:)./(qbv1(t1,:,:)+exp(lnsigv_adv*(ones(1,ni,nrep)))./repmat(quana(t1,:),[1,1,nrep]))...
        .*exp(lnsigv_adv*(ones(1,ni,nrep)))./repmat(quana(t1,:),[1,1,nrep])+(ones(1,ni,nrep)...
        -repmat((ah(t1,:)),[1,1,nrep])).*qbv1(t1,:,:);
    
        qbdv1(t1+1,:,:)=qbdv1(t1,:,:)-repmat(((ah(t1,:))),[1,1,nrep])...
        .*qbc1(t1,:,:).*qbc1(t1,:,:)...
        ./(qbv1(t1,:,:)+exp(lnsigv_adv*(ones(1,ni,nrep)))./repmat(quana(t1,:),[1,1,nrep]));
    
        qbdv1t2(t1+1,:,:)=qbdv1t2(t1,:,:)-repmat(((ah(t1,:))),[1,1,nrep])...
        .*qbc1t2(t1,:,:).*qbc1t2(t1,:,:)...
        ./(qbv1(t1,:,:)+exp(lnsigv_adv*(ones(1,ni,nrep)))./repmat(quana(t1,:),[1,1,nrep]));
    
        qbc1(t1+1,:,:)=repmat(((ah(t1,:))),[1,1,nrep])...
        .*qbc1(t1,:,:)./(qbv1(t1,:,:)+exp(lnsigv_adv*(ones(1,ni,nrep)))./repmat(quana(t1,:),[1,1,nrep]))...
        .*exp(lnsigv_adv*(ones(1,ni,nrep)))./repmat(quana(t1,:),[1,1,nrep])+(ones(1,ni,nrep)...
        -repmat((ah(t1,:)),[1,1,nrep])).*qbc1(t1,:,:);
        
        qbc1t2(t1+1,:,:)=repmat(((ah(t1,:))),[1,1,nrep])...
        .*qbc1t2(t1,:,:)./(qbv1(t1,:,:)+exp(lnsigv_adv*(ones(1,ni,nrep)))./repmat(quana(t1,:),[1,1,nrep]))...
        .*exp(lnsigv_adv*(ones(1,ni,nrep)))./repmat(quana(t1,:),[1,1,nrep])+(ones(1,ni,nrep)...
        -repmat((ah(t1,:)),[1,1,nrep])).*qbc1t2(t1,:,:);
     
        qbm1(t1+1,:,:)=qbm1(t1,:,:)+...
            repmat((ah(t1,:)),[1,1,nrep]) ...
		    .*(trueq(t1,:,:)...
            +ones(1,ni,nrep).*(sqrt(exp(lnsigv_adv*(ones(1,ni,nrep)) ...
			)).*repmat(reshape(err_sig_adv(t1,:),[1,1,nrep]),[1,ni,1]))-qbm1(t1,:,:))...
            .*qbv1(t1,:,:)./(qbv1(t1,:,:)+exp(lnsigv_adv*(ones(1,ni,nrep)))./repmat(quana(t1,:),[1,1,nrep])); 
        
        qbdm1(t1+1,:,:)=qbdm1(t1,:,:)+...
            repmat((ah(t1,:)),[1,1,nrep]) ...
		    .*(trueq(t1,:,:)...
            +ones(1,ni,nrep).*(sqrt(exp(lnsigv_adv*(ones(1,ni,nrep)) ...
			)).*repmat(reshape(err_sig_adv(t1,:),[1,1,nrep]),[1,ni,1]))-qbm1(t1,:,:))...
            .*qbc1(t1,:,:)./(qbv1(t1,:,:)+exp(lnsigv_adv*(ones(1,ni,nrep)))./repmat(quana(t1,:),[1,1,nrep])); 
  
        qbdm1t2(t1+1,:,:)=qbdm1t2(t1,:,:)+...
            repmat((ah(t1,:)),[1,1,nrep]) ...
		    .*(trueq(t1,:,:)...
            +ones(1,ni,nrep).*(sqrt(exp(lnsigv_adv*(ones(1,ni,nrep)) ...
			)).*repmat(reshape(err_sig_adv(t1,:),[1,1,nrep]),[1,ni,1]))-qbm1(t1,:,:))...
            .*qbc1t2(t1,:,:)./(qbv1(t1,:,:)+exp(lnsigv_adv*(ones(1,ni,nrep)))./repmat(quana(t1,:),[1,1,nrep]));       
   
        % then use consumption signals (so use t1+1 as these are already
        % adjusted for ad signals)
   
         qbv1(t1+1,:,:)=repmat(((yh(t1,:)+gh(t1,:))),[1,1,nrep])...
        .*qbv1(t1+1,:,:)./(qbv1(t1+1,:,:)+exp(lnsigv*(ones(1,ni,nrep)))./repmat(quan(t1,:),[1,1,nrep]))...
        .*exp(lnsigv*(ones(1,ni,nrep)))./repmat(quan(t1,:),[1,1,nrep])+(ones(1,ni,nrep)...
        -repmat((yh(t1,:)+gh(t1,:)),[1,1,nrep])).*qbv1(t1+1,:,:);
        
        qbdv1(t1+1,:,:)=qbdv1(t1+1,:,:)-repmat(((yh(t1,:)+gh(t1,:))),[1,1,nrep])...
        .*qbc1(t1+1,:,:).*qbc1(t1+1,:,:)...
        ./(qbv1(t1+1,:,:)+exp(lnsigv*(ones(1,ni,nrep)))./repmat(quan(t1,:),[1,1,nrep]));
    
        qbdv1t2(t1+1,:,:)=qbdv1t2(t1+1,:,:)-repmat(((yh(t1,:)+gh(t1,:))),[1,1,nrep])...
        .*qbc1t2(t1+1,:,:).*qbc1t2(t1+1,:,:)...
        ./(qbv1(t1+1,:,:)+exp(lnsigv*(ones(1,ni,nrep)))./repmat(quan(t1,:),[1,1,nrep]));
    
        qbc1(t1+1,:,:)=repmat(((yh(t1,:)+gh(t1,:))),[1,1,nrep])...
        .*qbc1(t1+1,:,:)./(qbv1(t1+1,:,:)+exp(lnsigv*(ones(1,ni,nrep)))./repmat(quan(t1,:),[1,1,nrep]))...
        .*exp(lnsigv*(ones(1,ni,nrep)))./repmat(quan(t1,:),[1,1,nrep])+(ones(1,ni,nrep)...
         -repmat((yh(t1,:)+gh(t1,:)),[1,1,nrep])).*qbc1(t1+1,:,:);
        
        qbc1t2(t1+1,:,:)=repmat(((yh(t1,:)+gh(t1,:))),[1,1,nrep])...
        .*qbc1t2(t1+1,:,:)./(qbv1(t1+1,:,:)+exp(lnsigv*(ones(1,ni,nrep)))./repmat(quan(t1,:),[1,1,nrep]))...
        .*exp(lnsigv*(ones(1,ni,nrep)))./repmat(quan(t1,:),[1,1,nrep])+(ones(1,ni,nrep)...
         -repmat((yh(t1,:)+gh(t1,:)),[1,1,nrep])).*qbc1t2(t1+1,:,:);
     
         qbm1(t1+1,:,:)=qbm1(t1+1,:,:)+...
            repmat((yh(t1,:)+gh(t1,:)),[1,1,nrep]) ...
		    .*(trueq(t1,:,:)...
            +ones(1,ni,nrep).*(sqrt(exp(lnsigv*(ones(1,ni,nrep)) ...
			)).*repmat(reshape(err_sig(t1,:),[1,1,nrep]),[1,ni,1]))-qbm1(t1+1,:,:))...
            .*qbv1(t1+1,:,:)./(qbv1(t1+1,:,:)+exp(lnsigv*(ones(1,ni,nrep)))./repmat(quan(t1,:),[1,1,nrep])); 
        
        qbdm1(t1+1,:,:)=qbdm1(t1+1,:,:)+...
            repmat((yh(t1,:)+gh(t1,:)),[1,1,nrep]) ...
		    .*(trueq(t1,:,:)...
            +ones(1,ni,nrep).*(sqrt(exp(lnsigv*(ones(1,ni,nrep)) ...
			)).*repmat(reshape(err_sig(t1,:),[1,1,nrep]),[1,ni,1]))-qbm1(t1+1,:,:))...
            .*qbc1(t1+1,:,:)./(qbv1(t1+1,:,:)+exp(lnsigv*(ones(1,ni,nrep)))./repmat(quan(t1,:),[1,1,nrep])); 
  
        qbdm1t2(t1+1,:,:)=qbdm1t2(t1+1,:,:)+...
            repmat((yh(t1,:)+gh(t1,:)),[1,1,nrep]) ...
		    .*(trueq(t1,:,:)...
            +ones(1,ni,nrep).*(sqrt(exp(lnsigv*(ones(1,ni,nrep)) ...
			)).*repmat(reshape(err_sig(t1,:),[1,1,nrep]),[1,ni,1]))-qbm1(t1+1,:,:))...
            .*qbc1t2(t1+1,:,:)./(qbv1(t1+1,:,:)+exp(lnsigv*(ones(1,ni,nrep)))./repmat(quan(t1,:),[1,1,nrep]));
  	
            
   
        end;
   
		zzz1=reshape(permute(zzz1,[2,1,3]),[ni*times(nr,1),nrep]);
        % to calculate LL of full sample, use following three lines:
		%idx=find((ones(n,1)-ini)==1);
		%occ(nr,1)=size(idx,1);
        %q1=(prod(zzz1(idx',:)*1.1,1)); % nrep by 1
        % to calculate LL of estimation sample (i.e., excl holdout=excl last shopping trip), use following four lines:
        idx=find((ones(n,1)-ini)==1);
        occ(nr,1)=size(idx,1)-ni;
        idxe=idx(1:occ(nr,1),:);
        q1=(prod(zzz1(idxe',:)*1.1,1));
	
	sl(nr,1)=sum(q1)/nrep;
end;
ll=-sum((log(sl+.00000000001)-occ*log(1.1)),1);

